/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Trie.xs. Do not edit this file, edit Trie.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Net/IP/Match/Trie.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#ifdef __cplusplus
}
#endif

// for debug fixme
//#define DEBUG 1

#ifdef DEBUG
#  define DIAG(fmt, ...) PerlIO_printf(PerlIO_stderr(), fmt, __VA_ARGS__);
#  define DUMPTREE(pt) { CIDR_TRIE *xt = pt; xt = xt->child[10]; xt = xt->child[0]; xt = xt->child[0]; xt = xt->child[1]; DIAG("    DUMPTREE %s\n", xt->name); }
#else
#  define DIAG(fmt, ...)
#  define DUMPTREE(pt, ...)
#endif

#define CIDR_TABLE_BITS 8
#define CIDR_TABLE_SIZE (1 << CIDR_TABLE_BITS)

typedef struct CIDR_TRIE {
  const char       *name;
  uint32_t          bits;
  struct CIDR_TRIE *child[CIDR_TABLE_SIZE];
} CIDR_TRIE;

static int itonetmask(int n, uint32_t *netmask)
{
  uint32_t m;

  if (n < 0 || 32 < n) return 0;

  m = 1UL << (32 - n);
  --m;
  *netmask = ~m;
  return 1;
}

static int is_leaf(const CIDR_TRIE *pt) {
  return pt->child[0] == pt;
}

static CIDR_TRIE *new_trie_node() {
  int i;
  CIDR_TRIE *pt;

  Newxz(pt, 1, CIDR_TRIE);

  pt->name = 0;
  pt->bits = 0;
  for (i = 0; i < CIDR_TABLE_SIZE; ++i)
    pt->child[i] = pt;
  return pt;
}

static void init_root(CIDR_TRIE *trie_root)
{
  int i;
  CIDR_TRIE *nullnode;

  nullnode = new_trie_node();
  for (i = 0; i < CIDR_TABLE_SIZE; ++i)
    trie_root->child[i] = nullnode;
}

static CIDR_TRIE* digg_trie(CIDR_TRIE *child) {
  int i;
  CIDR_TRIE *parent = new_trie_node();

  for (i = 0; i < CIDR_TABLE_SIZE; ++i)
    parent->child[i] = child;
  return parent;
}

static int update_leaf(CIDR_TRIE *pt, CIDR_TRIE *leaf)
{
  int used = 0;
  int i;

  for (i = 0; i < CIDR_TABLE_SIZE; ++i) {
    CIDR_TRIE *next = pt->child[i];
    if (is_leaf(next)) {
      if (next->bits < leaf->bits) {
        pt->child[i] = leaf;
        used = 1;
      }
    }
    else {
      used |= update_leaf(next, leaf);
    }
  }
  return used;
}


#line 117 "temp/Trie.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 261 "temp/Trie.c"

XS_EUPXS(XS_Net__IP__Match__Trie__initialize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__IP__Match__Trie__initialize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 113 "lib/Net/IP/Match/Trie.xs"
    CIDR_TRIE *root, *nullnode;
    int i;
#line 275 "temp/Trie.c"
	SV *	RETVAL;
#line 116 "lib/Net/IP/Match/Trie.xs"
    root     = new_trie_node();
    nullnode = new_trie_node();
    for (i = 0; i < CIDR_TABLE_SIZE; ++i)
      root->child[i] = nullnode;
    sv_magic(SvRV(self), NULL, PERL_MAGIC_ext, NULL, 0);
    mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj = (void *)root;
#line 284 "temp/Trie.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__IP__Match__Trie__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__IP__Match__Trie__add)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, name, network, netmask");
    {
	SV *	self = ST(0)
;
	SV *	name = ST(1)
;
	SV *	network = ST(2)
;
	SV *	netmask = ST(3)
;
#line 130 "lib/Net/IP/Match/Trie.xs"
    CIDR_TRIE *pt, *p_leaf;
    size_t    len;
    in_addr_t addr;
    uint32_t  nm;
#line 310 "temp/Trie.c"
#line 135 "lib/Net/IP/Match/Trie.xs"
    DIAG(">>%s %s %s/%d\n", "add", SvPV_nolen(name), SvPV_nolen(network), SvIV(netmask));
    DUMPTREE((CIDR_TRIE *)mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj);
    if (!inet_aton(SvPV_nolen(network), (struct in_addr *)&addr)) {
      warn("inet_aton: failed");
    }
    len = SvIV(netmask);
    if (!itonetmask(len,&nm)) {
      warn("itonetmask: failed");
    }
    DIAG("  nm  :%08X\n", nm);
    addr = ntohl(addr);
    DIAG("  addr:%08X\n", addr);
    addr &= nm;
    DIAG("  addr&nm:%08X\n", addr);

    pt     = (CIDR_TRIE *)mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj;

    p_leaf = new_trie_node();
    p_leaf->name = SvPV_nolen(newSVsv(name));
    p_leaf->bits = len;

    while (len > CIDR_TABLE_BITS) {
      int b = addr >> (32 - CIDR_TABLE_BITS);
      CIDR_TRIE *next = pt->child[b];
      if (is_leaf(next)) {
        pt->child[b] = next = digg_trie(next);
      }
      pt = next;
      addr <<= CIDR_TABLE_BITS;
      len -= CIDR_TABLE_BITS;
    }
    {
      int i;
      const int bmin = addr >> (32 - CIDR_TABLE_BITS);
      const int bmax = bmin + (1 << (CIDR_TABLE_BITS - len));
      int used = 0; // delete p_leaf if it is not used.
      for (i = bmin; i < bmax; ++i) {
        CIDR_TRIE *target = pt->child[i];
        if (is_leaf(target)) {
          if (target->bits < p_leaf->bits) {
            pt->child[i] = p_leaf;
            used = 1;
          }
        }
        else {
          int j;
          for (j = 0; j < CIDR_TABLE_SIZE; ++j) {
            used |= update_leaf(target, p_leaf);
          }
        }
      }
    }
    DUMPTREE((CIDR_TRIE *)mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj);
#line 365 "temp/Trie.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__IP__Match__Trie_match_ip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__IP__Match__Trie_match_ip)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ip");
    {
	SV *	self = ST(0)
;
	SV *	ip = ST(1)
;
#line 194 "lib/Net/IP/Match/Trie.xs"
    CIDR_TRIE *pt;
    in_addr_t addr;
    uint8_t   *octed;
#line 386 "temp/Trie.c"
	SV *	RETVAL;
#line 198 "lib/Net/IP/Match/Trie.xs"
    DIAG(">>%s %s\n", "match_ip", SvPV_nolen(ip));
    pt = (CIDR_TRIE *)mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj;
    if (!inet_aton(SvPV_nolen(ip), (struct in_addr *)&addr)) {
      warn("inet_aton: failed");
      XSRETURN_EMPTY;
    }

    DIAG("  addr:%08X\n", addr);
    octed = (uint8_t *)&addr;
#if CIDR_TABLE_BITS == 8
    pt = pt->child[*octed++];
    pt = pt->child[*octed++];
    pt = pt->child[*octed++];
    pt = pt->child[*octed++];
#elif CIDR_TABLE_BITS == 16
    pt = pt->child[octed[0] * 256 + octed[1]];
    pt = pt->child[octed[2] * 256 + octed[3]];
#else
#error CIDR_TABLE_BITS must be 8 or 16.
#endif
    DIAG("    name:%s\n", pt->name);
    RETVAL = newSVpv(pt->name != NULL ? pt->name : "", 0);
#line 411 "temp/Trie.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__IP__Match__Trie_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__IP__Match__Trie_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 227 "lib/Net/IP/Match/Trie.xs"
    CIDR_TRIE *root;
#line 430 "temp/Trie.c"
#line 229 "lib/Net/IP/Match/Trie.xs"
    DIAG(">>%s\n", "DESTROY");
    root = (CIDR_TRIE *)mg_find(SvRV(self), PERL_MAGIC_ext)->mg_obj;
    /* todo: free all node of tree */
    Safefree(root);
#line 436 "temp/Trie.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__IP__Match__Trie); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__IP__Match__Trie)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::IP::Match::Trie::_initialize", XS_Net__IP__Match__Trie__initialize);
        newXS_deffile("Net::IP::Match::Trie::_add", XS_Net__IP__Match__Trie__add);
        newXS_deffile("Net::IP::Match::Trie::match_ip", XS_Net__IP__Match__Trie_match_ip);
        newXS_deffile("Net::IP::Match::Trie::DESTROY", XS_Net__IP__Match__Trie_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

